require 'test/unit'

require File.expand_path( File.dirname( __FILE__ ) + '/../test_with_compilation' )

require File.expand_path( File.dirname( __FILE__ ) + '/../../lib/mxx_ru/externals.rb' )

probe = MxxRu::Helpers.external_tool_version_probe(
  'cmake --version', /^cmake version\s(\S+)\s/ )

if probe
  puts "CMake version #{probe}"

  class TC_CMakeBuild < Test::Unit::TestCase
    include TestWithCompilation

    test_path 'tests/cmake'

    test_case :successful_compile_and_link do
      assert_nothing_raised {
        build( 'build.rb' )
        clean( 'build.rb' )
      }
    end

  end
else
  puts "CMake not found, test skipped #{__FILE__}"
end

