require 'test/unit'

require File.expand_path( File.dirname( __FILE__ ) + '/../../test_with_compilation' )

class TC_NormalBuild < Test::Unit::TestCase
  include TestWithCompilation

  test_path 'tests/cpp/lib_from_lib_dependecies'

  FIRST = 'first.ut.rb'
  SECOND = 'second.ut.rb'

  test_case :first_and_second_builds do
    write_first_content
    clean FIRST
    clean SECOND
    build FIRST

    puts "sleeping for several seconds..."
    sleep( 2 )
    write_second_content
    build SECOND

    clean FIRST, SECOND
  end

  def write_first_content
    File.open( 'a.cpp', 'w' ) do |file|
      file << <<EOS
#include <cstdio>

void A() { std::printf( "A\\n" ); }
EOS
    end
  end

  def write_second_content
    File.open( 'a.cpp', 'w' ) do |file|
      file << <<EOS
#include <cstdio>

void A() { std::printf( "A2\\n" ); }
EOS
    end
  end
end

