require 'test/unit'

require 'mxx_ru/generators/impl/cpp/generation'

class TC_GeneratorsCppTemplateParams < Test::Unit::TestCase
  MODULE = MxxRu::Generators::Impl::Cpp unless defined?( MODULE )

  class TestReceiver
    attr_reader :result

    def receive( generation_result, output_file_name )
      @result = generation_result
    end
  end

  def test_empty_args
    r = TestReceiver.new
    assert_nothing_raised do
      MODULE.generate_for( MODULE::EXE, [], r )
    end
  end

  def test_implib_path_defined
    r = TestReceiver.new
    path = 'lib'

    assert_nothing_raised do
      MODULE.generate_for( MODULE::EXE, ['--implib-path', path], r )
    end

    assert_equal( true, r.result.include?( "implib_path '#{path}'" ) )
  end
end

